Codeforces Round #599 (Div. 2) D. 0-1 MST(bfs+set)

Codeforces Round #599 (Div. 2)

D. 0-1 MST

Description

Ujan has a lot of useless stuff in his drawers, a considerable part of which are his math notebooks: it is time to sort them out. This time he found an old dusty graph theory notebook with a description of a graph.

It is an undirected weighted graph on n vertices. It is a complete graph: each pair of vertices is connected by an edge. The weight of each edge is either 0 or 1; exactly m edges have weight 1, and all others have weight 0.

Since Ujan doesn't really want to organize his notes, he decided to find the weight of the minimum spanning tree of the graph. (The weight of a spanning tree is the sum of all its edges.) Can you find the answer for Ujan so he stops procrastinating?

Input

The first line of the input contains two integers n and m (1≤n≤105, 0≤m≤min(n(n−1)2,105)), the number of vertices and the number of edges of weight 1 in the graph.

The i-th of the next m lines contains two integers ai and bi (1≤ai,bi≤n, ai≠bi), the endpoints of the i-th edge of weight 1.

It is guaranteed that no edge appears twice in the input.

Output

Output a single integer, the weight of the minimum spanning tree of the graph.

input1

6 11
1 3
1 4
1 5
1 6
2 3
2 4
2 5
2 6
3 4
3 5
3 6

output1

2

题意:

给你一个n个点的完全图,其中m条边权值是1,其他边的权值是0。求出权值最小的生成树权值的大小。

题解

我们把n个点放到set容器中和建一个set容器的图,然后通过bfs暴力,求出连通块的个数,答案就是连通块的个数-1。

#include <bits/stdc++.h>
using namespace std;
#define ll long long
const int N=1e5+10;
set<int>G[N],s;
int vis[N];
void bfs(int x)
{
    queue<int>q;
    q.push(x);
    s.erase(x);
    while(q.size()>0)
    {
        int y=q.front();
        q.pop();
        if(vis[y])
            continue;
        vis[y]=1;

        for(auto it=s.begin();it!=s.end();)
        {
            int v=*it;
            ++it;
            if(G[y].find(v)==G[y].end())
            {
                q.push(v);//cout<<"-";
                s.erase(v);
            }
        }
    }
}
int main()
{
   int n,m;
   cin>>n>>m;
   for(int i=1;i<=n;i++)
   {
       s.insert(i);
   }
   for(int i=1;i<=m;i++)
   {
       int x,y;
       cin>>x>>y;
       G[x].insert(y);
       G[y].insert(x);
   }
   int ans=0;

   for(int i=1;i<=n;i++)
   {
       if(!vis[i])
       {
           bfs(i);
           ans++;
       }
   }
   cout<<ans-1<<"\n";
    return 0;
}

猜你喜欢

转载自www.cnblogs.com/hh13579/p/11809744.html